#!/bin/bash
#
# Shell script to change all the coding style we have
#
# Copyright 2014 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 7 february 2014
#
# where you have store the script and the awk-program
DIR="<installation directory>/CodingStyle"
WHERE_DIFFS="/home/Diffs"
#
#set -x
#
numberOfParameter=$#
if [ $numberOfParameter -eq 0 ] ;
then
  # Parameter is missing, use the actual directory
  WHERE="./"
else
  WHERE=${1}
fi
nameOfTheScript=${0}
#
if [ -d ${WHERE} ] ;
then
  # Is a directory
  if [ -r ${WHERE} ] ;
  then
    if [ -a ".no_coding_style" ] 
    then
      #echo "Datei .no_coding_file gefunden"
      exit
    fi
    if [ -a ".no_recursion" ] 
    then
      foo = 0;
      # do not explore the next directory(ies)
    else
      cd ${WHERE}
      liste=`ls -1A`
      for file_1 in ${liste}
      do
        ${nameOfTheScript} ${file_1}
      done
      cd ..
    fi
  fi
else
  # Is a file
  do_it="no"
  base_1=`basename ${WHERE} .h`
  if [ ${base_1} != ${WHERE} ] ;
  then
    do_it="yes"
  fi
  base_1=`basename ${WHERE} .cpp`
  if [ ${base_1} != ${WHERE} ] ;
  then
    do_it="yes"
  fi
  if [ ${do_it} == "yes" ] ;
  then
    pwd > pwd.txt
    # /home/guy-kde/projects/kdepimlibs/akonadi/contact/actions
    # 123456789=123456789=123456789=
    LAST_DIR=`cut --bytes=24- pwd.txt`
    rm pwd.txt
    #echo "LAST_DIR="${LAST_DIR}
    mkdir -p ${WHERE_DIFFS}/${LAST_DIR}
    #
    astyle \
        --indent=spaces \
        --max-instatement-indent=80 \
        --indent-cases \
        --pad-header \
        --pad-oper \
        --unpad-paren \
        --align-pointer=name \
        --align-reference=name \
        --max-instatement-indent=80 \
        --min-conditional-indent=1 \
        ${WHERE}
    #
    #    --suffix=none \
    #
    # correction for the SIGNAL and SLOT macros
    # qt5
    normalize --modify ${WHERE}
    #
    # add <SPACE> vor ": public"
    gawk -f ${DIR}/Public-change.awk ${WHERE} > ${WHERE}-p
    mv ${WHERE}-p ${WHERE}
    #
    # change " & " to " &"
    gawk -f ${DIR}/spaceUNDspace-change.awk ${WHERE} > ${WHERE}-a
    mv ${WHERE}-a ${WHERE}
    #
    # change "[ " to "[" and " ]" to "]"
    gawk -f ${DIR}/spaceInArray-change.awk ${WHERE} > ${WHERE}-k
    mv ${WHERE}-k ${WHERE}
    #
    # delete one line if two empties lines are present 
    gawk -f ${DIR}/Twice-change.awk ${WHERE} > ${WHERE}-b
    mv ${WHERE}-b ${WHERE}
    #
    # delete first/last empty line(s)
    gawk -f ${DIR}/First-change.awk ${WHERE} > ${WHERE}-c
    mv ${WHERE}-c ${WHERE}
    #
    # lines with initialization(s)
    gawk -f ${DIR}/Default-1-change.awk < ${WHERE} > ${WHERE}-d1
    mv ${WHERE}-d1 ${WHERE}
    gawk -f ${DIR}/Default-2-change.awk < ${WHERE} > ${WHERE}-d2
    mv ${WHERE}-d2 ${WHERE}
    #
    # corrections for "switch"
    gawk -f ${DIR}/Switch-Brace-check-change.awk -vmode=change ${WHERE} > ${WHERE}-c
    mv ${WHERE}-c ${WHERE}
    #
    # change <SPACE> after keyword
    ${DIR}/coding-style-change-SpaceAfter.sh ${WHERE}
    #
    if [ -f "${DIR}/private_job" ] 
    then
      . ${DIR}/private_job
    fi
  fi
fi
